<?
// Configuration de plusieurs services de la FoxLego

// Les constantes

define('CHEMIN_OUTILS','/usr/local/bin/');
define('CHEMIN_FICHIERS','/usr/local/etc/');
define('CHEMIN_BT_ADRESSE',CHEMIN_FICHIERS.'bt_adresse');

define('CONFIG_INTERF_MASTER','/etc/network/interfaces.master');
define('CONFIG_INTERF_SLAVE','/etc/network/interfaces.slave');
define('CONFIG_HOSTAPD','/etc/hostapd/hostapd.conf');

define('COMMANDE_INT','ip -o link show dev $INT');
define('COMMANDE_ADR','ip -o address show dev $INT');
define('COMMANDE_SID',"grep '^ *wpa-ssid' \$CONFIG | sed -e 's/.*ssid//' | sed -e 's/#.*//'");
define('COMMANDE_MID',"grep '^\$TOKEN' \$CONFIG | cut -f2 -d=");
define('COMMANDE_MOD',"iwconfig \$INT | tr ' ' '\n' | grep '^[Mm]ode:' | cut -f2 -d:");
define('COMMANDE_APA',"iwconfig \$INT | grep 'Access Point' | sed -e 's/.*: //'");
define('COMMANDE_RST','super reset_$INT');
define('COMMANDE_NET','super switchmode $MODE $ARGS');
define('COMMANDE_VRF','pidof -x $PROC');
define('COMMANDE_EXE','cd /tmp ; '.
                      'nohup super $PROC $ARGS >/dev/null 2>/dev/null &'.
                      'sleep 2');
define('COMMANDE_TUE','super kill_$PROC ; sleep 2');
define('COMMANDE_HLT','super halt');
define('COMMANDE_UPT','uptime');
define('COMMANDE_BTA','blueagent');

define('RELOAD_TIMEOUT',5000);

$arguments=array(
  'capture' => '-s',
  'controle' => '-s $BT_ADRESSE',
  'mjpg_streamer' => '-i "/usr/local/lib/input_uvc.so"  '.
                     '-o "/usr/local/lib/output_http.so"'
  );

// Recuperation de parametres

$item=$_REQUEST['item'];
$data=$_REQUEST['data'];
$submit=$_REQUEST['submit'];
if(!isset($item)) die('Aucun service a configurer !');

// Configuration de l'item specifie

$donnees='';
// -- interface reseau
if(preg_match('/^int_/',$item)>0){
  $parts=explode('_',$item); $int=$parts[1];
  if($submit!=''){
    $cmd_rst=str_replace('$INT',$int,COMMANDE_RST);
    $sortie_rst=shell_exec($cmd_rst);
    }
  $cmd_int=str_replace('$INT',$int,COMMANDE_INT);
  $cmd_adr=str_replace('$INT',$int,COMMANDE_ADR);
  $sortie_int=shell_exec($cmd_int);
  $sortie_adr=shell_exec($cmd_adr);
  $couleur=preg_match('/[<,]UP[,>]/',$sortie_int)?'green':'red';
  $select=preg_grep('/ inet /',explode("\n",$sortie_adr));
  $ligne=array_shift($select);
  $adresse=preg_replace('/.* inet ([^ ]*) .*/','\1',$ligne);
  if($adresse=='') $adresse='absente';
  $infos="IPv4 = <font color=\"$couleur\">$adresse</font>";
  $label="Interface <tt>$int</tt>";
  $verbes=array('Relancer');
  }

// -- mode reseau
if(preg_match('/^mode_/',$item)>0){
  $parts=explode('_',$item); $mode=$parts[1];
  if($submit!=''){
    $syntax=true;
    $args='';
    if($data!='') $dparts=explode('/',trim($data));
    if($data!='' && $mode=='slave'){
      if(count($dparts)<2) $syntax=false;
      if($syntax && !in_array($dparts[1],array('EAP','PSK'))) $syntax=false;
      if($syntax && $dparts[1]=='EAP' && count($dparts)!=4) $syntax=false;
      if($syntax && $dparts[1]=='PSK' && count($dparts)!=3) $syntax=false;
      if($syntax && $dparts[1]=='EAP'){
        $pass=implode('/',array_slice($dparts,3));
        $args="EAP \"${dparts[0]}\" ${dparts[2]} \"$pass\"";
        }
      if($syntax && $dparts[1]=='PSK'){
        $pass=implode('/',array_slice($dparts,2));
        $args="PSK \"${dparts[0]}\" \"$pass\"";
        }
      }
    if($data!='' && $mode=='master'){
      if(count($dparts)!=2) $syntax=false;
      $channel=(int)$dparts[1];
      if($channel<1 || $channel>14) $syntax=false;
      if($syntax) $args="${dparts[0]} $channel";
      }
    if($syntax){
      $cmd=str_replace('$MODE',$mode,COMMANDE_NET);
      $cmd=str_replace('$ARGS',$args,$cmd);
      $output=shell_exec($cmd);
      }
    }
  $cmd=str_replace('$CONFIG',CONFIG_INTERF_SLAVE,COMMANDE_SID);
  $ssid_slave=shell_exec($cmd);
  $cmd=str_replace('$CONFIG',CONFIG_HOSTAPD,COMMANDE_MID);
  $cmd_ssid=str_replace('$TOKEN','ssid',$cmd);
  $ssid_master=shell_exec($cmd_ssid);
  $cmd_channel=str_replace('$TOKEN','channel',$cmd);
  $channel_master=shell_exec($cmd_channel);
  $cmd=str_replace('$INT','wlan0',COMMANDE_MOD);
  $mode_real=strtolower(trim(shell_exec($cmd)));
  $cmd=str_replace('$INT','wlan0',COMMANDE_APA);
  $ap_real=shell_exec($cmd);
  if($mode=='slave'){
    $infos="SSID configuré : ${ssid_slave}<br>";
    if($mode_real=='managed'){
      $tmode="<font color=\"green\">${mode_real}</font>";
      $infos .= "Interface mode ${tmode}<br>";
      $infos .= "Point d'accès : ${ap_real}";
      }
    }
  if($mode=='master'){
    $infos="SSID configuré : ${ssid_master}<br>";
    $infos .= "Canal configuré : ${channel_master}<br>";
    if($mode_real=='master'){
      $tmode="<font color=\"green\">${mode_real}</font>";
      $infos .= "Interface : mode ${tmode}";
      }
    }
  $label="Mode réseau <tt>$mode</tt>";
  $verbes=array('Configure');
  if($mode=='slave'){
    $dlabel="identification<br>".
            "<tt>ssid/EAP/identite/mot de passe</tt><br>".
            "<tt>ssid/PSK/mot de passe</tt>";
    $donnees="<input type=\"text\" size=30 id=\"${item}_data\"> &nbsp; ";
    }
  if($mode=='master'){
    $dlabel="identification<br>".
            "<tt>ssid/canal</tt>";
    $donnees="<input type=\"text\" size=30 id=\"${item}_data\"> &nbsp; ";
    }
  }

// -- processus serveurs
if(preg_match('/^proc_/',$item)>0){
  $parts=explode('_',$item);
  array_shift($parts);
  $proc=implode('_',$parts);
  if($submit=='Lancer'){
    $bt_adresse=trim(file_get_contents(CHEMIN_BT_ADRESSE));
    $args=$arguments[$proc];
    if(!isset($args)) $args='';
    $args=str_replace('$BT_ADRESSE',$bt_adresse,$args);
    $cmd=str_replace('$PROC',$proc,COMMANDE_EXE);
    $cmd=str_replace('$ARGS',$args,$cmd);
    $output=shell_exec($cmd);
    }
  if($submit=='Arrêter'){
    $cmd=str_replace('$PROC',$proc,COMMANDE_TUE);
    $output=shell_exec($cmd);
    }
  $cmd=str_replace('$PROC',$proc,COMMANDE_VRF);
  $pid=trim(shell_exec($cmd));
  $couleur=is_numeric($pid)?'green':'red';
  if($pid=='') $pid="absent";
  $infos="PID = <font color=\"$couleur\">$pid</font>";
  $label="Démon <tt>$proc</tt>";
  $verbes=array('Lancer','Arrêter');
  }

// -- code bluetooth
if($item=='code'){
  if($submit=='Changer' && $data!=''){
    $cmd=str_replace('$PROC',COMMANDE_BTA,COMMANDE_TUE);
    $output=shell_exec($cmd);
    $cmd=str_replace('$PROC',COMMANDE_BTA,COMMANDE_EXE);
    $cmd=str_replace('$ARGS',$data,$cmd);
    $output=shell_exec($cmd);
    }
  $cmd=str_replace('$PROC',COMMANDE_BTA,COMMANDE_VRF);
  $pid=trim(shell_exec($cmd));
  $couleur=is_numeric($pid)?'green':'red';
  if($pid=='') $pid="absent";
  $infos="PID = <font color=\"$couleur\">$pid</font>";
  $label="Gestion du code BlueTooth";
  $verbes=array('Changer');
  $dlabel="code";
  $donnees="<input type=\"text\" size=5 id=\"${item}_data\"> &nbsp; ";
  }

// -- adresse bluetooth
if($item=='adresse'){
  if($submit=='Changer'){
    $reste=preg_replace('/[0-9a-fA-F]*/','',$data);
    if($reste==':::::') file_put_contents(CHEMIN_BT_ADRESSE,trim($data));
    }
  $adresse=trim(file_get_contents(CHEMIN_BT_ADRESSE));
  $infos="MAC = $adresse";
  $label="Adresse BlueTooth";
  $verbes=array('Changer');
  $dlabel="adresse";
  $donnees="<input type=\"text\" size=18 id=\"${item}_data\"> &nbsp; ";
  }

// -- arret de la machine
if($item=='halt'){
  if($submit=='Arrêter') $output=shell_exec(COMMANDE_HLT);
  $output=shell_exec(COMMANDE_UPT);
  $parts=explode(',',trim($output));
  $infos=trim($parts[0]);
  $label="Système d'exploitation";
  $verbes=array('Arrêter');
  }

// Partie generique
$action='';
foreach($verbes as $verbe){
  $js="configure('${item}','$verbe');";
  $timeout=RELOAD_TIMEOUT;
  if($item=='mode_master') $js .= "setTimeout('configure_slave();',$timeout);";
  if($item=='mode_slave') $js .= "setTimeout('configure_master();',$timeout);";
  $action .= "<input type=\"submit\" value=\"$verbe\" onclick=\"$js\">";
  }
if($donnees=='') $tdonnees='';
else $tdonnees="<table><tr><td>$dlabel</td></tr><tr><td>$donnees</td></tr></table>";
echo "<td>$label</td><td>$infos</td><td align=\"center\">$tdonnees</td><td>$action</td>\n";
?>
